; memory benchmarks for 8086

        BITS 16
        ORG 0x100

        push cs
        pop ds

        mov dx,msg
        mov ah,9
        int 0x21

a104:
        call read64k
        mov ax,word [temp3]
        add ax,0x1000
        mov word [temp3],ax
        cmp ax,0xA000
        jne a104

        mov dx,msg2
        mov ah,9
        int 0x21

        call write64k

        ; exit
        mov ax,0x4c00
        int 0x21

write64k:
        mov ah,0x2C     ; get time
        int 0x21
        mov word [temp1],dx
        xor ax,ax
        mov word [temp2],ax
a106:
        inc word [temp2]

;        push es
        mov es,word [temp3]
        mov cx,0x8000
        xor di,di
        rep stosw
;        pop es

        mov ah,0x2C     ; get time
        int 0x21
        sub dx,word [temp1]
        cmp dx,0x100
        jb a106
        jmp a105

read64k:
        mov ah,0x2C     ; get time
        int 0x21
        mov word [temp1],dx
        xor ax,ax
        mov word [temp2],ax
a103:
        inc word [temp2]

        push ds
        mov ds,word [temp3]
        mov cx,0x8000
        xor si,si
        rep lodsw
        pop ds

        mov ah,0x2C     ; get time
        int 0x21
        sub dx,word [temp1]
        cmp dx,0x100
        jb a103

a105:
        mov ax,dx
        mov bx,result2
        call writehex
        mov ax,word [temp2]
        mov bx,result
        call writehex

        mov dx,result
        mov ah,9
        int 0x21

        ret

writehex:
        mov ch,4
a102:
        mov cl,ah
        and cl,240
        shr cl,4
        add cl,48
        cmp cl,58
        jb a100
        add cl,7
a100:
        mov [bx],cl
        dec ch
        jz a101
        inc bx
        sal ax,4
        jmp a102
a101:
        ret

temp1:
        db 0,0
temp2:
        db 0,0
temp3:
        db 0,0x10
msg:
        db 'x86 16-bit memory benchmark',13,10,13,10
        db 'conventional memory reads',13,10,'$'
msg2:
        db 'video memory writes',13,10,'$'
result:
        db '     in '
result2:
        db '    ',13,10,'$'

